<?php

namespace ImageRecycle\Standalone;


class Database extends \SQLite3
{
    private $result = null;

    public function __construct($dbFile=null)
    {
        if($dbFile===null){
            $configuration = new \Configuration();
            $dbFile = dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'protected' . DIRECTORY_SEPARATOR . $configuration->database_name. '.db';
        }

        $this->open($dbFile, SQLITE3_OPEN_READWRITE | SQLITE3_OPEN_CREATE);
    }

    public function query($query)
    {
        $this->result = parent::query($query);
    }

    public function setResult($result){
        $this->result = $result;
    }

    public function getObjectList(){
        if(get_class($this->result)!=='SQLite3Result'){
            return null;
        }

        $results = array();
        while($result = $this->result->fetchArray(SQLITE3_ASSOC)) {
            $results[] = (object)$result;
        }
        $this->result->finalize();

        return $results;
    }

    public function getObject(){
        if(get_class($this->result)!=='SQLite3Result'){
            return null;
        }
        $result = $this->result->fetchArray(SQLITE3_ASSOC);
        $this->result->finalize();
        if($result === false){
            return false;
        }
        return (object)$result;
    }

}