<?php

namespace ImageRecycle\Standalone;


class View
{

    //name of the default template use by the view
    protected $template = 'default';

    protected $templateTitle = 'ImageRecycle Standalone script';

    //Variable which will been assigned to the view for rendering
    protected $variables = array();

    public function set($variable,$value){
        if($value===null){
            //Delete the vairable
            if(isset($this->variables[$variable])){
                unset($this->variables[$variable]);
            }
        }
        $this->variables[$variable] = $value;
    }

    /**
     * Set the name of the template to use
     * @param $template string
     */
    public function setTemplate($template){
        $this->template = $template;
    }

    /**
     * Set the html title of rendered document
     * @param $title string
     */
    public function setTitle($title){
        $this->templateTitle = $title;
    }

    public function render($viewName){
        $segments = explode('/',$viewName);
        $viewFile = dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'views' . DIRECTORY_SEPARATOR . $segments[0] . DIRECTORY_SEPARATOR . $segments[1] . '.php';

        $viewContent = Renderer::render($viewFile,$this->variables);

        //Get the template content
        $templateFile = preg_replace('/[^a-zA-Z0-9]/','',$this->template);
        $templateContent = Renderer::render(dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'templates' . DIRECTORY_SEPARATOR . $templateFile . '.php',$this->variables);

        //Replace main content in template
        $templateContent = str_replace('<!--VIEW_CONTENT-->',$viewContent,$templateContent);

        //Replace title in template
        $templateContent = str_replace('<!--MAIN_TITLE-->',$this->templateTitle,$templateContent);

        echo $templateContent;
        die();
    }
}