<?php
//If there is no configuration file then we launch the installation process
if(!$configuration->password) {

    $view = new ImageRecycle\Standalone\View();
    $view->setTemplate('simple');

    switch (true) {
        //Show configuration form
        case isset($_GET['step']) && $_GET['step'] == '1':
            $view->setTitle('Installer - Configuration');

            $view->render('installer/password');
            break;

        //Password creation
        case isset($_GET['step']) && $_GET['step'] == '2':
            if (!isset($_POST['password']) || !isset($_POST['password2']) || trim($_POST['password'] === '') || $_POST['password'] !== $_POST['password2']) {
                $view->set('error', __('Password is empty or do not match, please try again'));
                $view->render('installer/password');
            }

            //Generate a secret password for database
            $dbName= substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, 10);
            $cronToken = substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, 10);
            $data = array('password' => $_POST['password'], 'database_name' => $dbName, 'cron_token' => $cronToken);

            //Update the configuration file
            $installer = new ImageRecycle\Standalone\Installer();
            if (!$installer->writeConfigFile($data)) {
                $view->set('error', __('Something went wrong while creating the configuration file, please update it manually.'));
                $view->render('installer/error');
                break;
            }

            if ($installer->installDatabase($dbName)) {
                $view->set('error', __('Something went wrong while creating the database.'));
                $view->render('installer/error');
                break;
            }

            $_SESSION['IR_CONNECTED'] = true;

            $view->render('installer/success');
            break;

        //All other cases
        case !isset($_GET['step']):
        default :
            $installer = new ImageRecycle\Standalone\Installer();
            $requirements = $installer->checkRequirements();

            $view->setTitle('Installer - Requirements');

            $view->set('requirements', $requirements);

            $requirementsOk = true;
            foreach ($requirements as $requirement) {
                if ($requirement === false) {
                    $requirementsOk = false;
                    break;
                }
            }
            $view->set('requirementsOk', $requirementsOk);

            $view->render('installer/default');
    }
}