<form method="POST" action="?page=settings" class="settings">
    <h4><?php _e('API Settings'); ?></h4>
    <button type="submit" class="waves-effect waves-light btn right" id="btnSave1"><i class="material-icons right">check</i><?php _e('Save'); ?></button>
    <p><?php _e('Get your api settings here <a target="_blank" href="https://www.imagerecycle.com/my-account/api-and-quota">API Informations</a>'); ?></p>
    <div class="row">
        <div class="input-field col s6">
            <i class="material-icons prefix">perm_identity</i>
            <input name="api_key" id="api_key" type="text" class="validate" value="<?php echo $api_key; ?>">
            <label for="api_key"><?php _e('API Key'); ?></label>
        </div>
        <div class="input-field col s6">
            <i class="material-icons prefix">vpn_key</i>
            <input name="api_secret" id="api_secret" type="text" class="validate" value="<?php echo $api_secret; ?>">
            <label for="api_secret"><?php _e('API Secret'); ?></label>
        </div>
    </div>

    <h4><?php _e('Optimization settings'); ?></h4>
    <div class="row">
        <div class="input-field col s3">
            <i class="material-icons prefix">settings_application</i>
            <select name="optimization_jpg">
                <option value="lossy" <?php echo $optimization_jpg=='lossy'?'selected':''; ?>><?php _e('Best Saving'); ?></option>
                <option value="lossless" <?php echo $optimization_jpg=='lossless'?'selected':''; ?>><?php _e('Lossless'); ?></option>
                <option value="none" <?php echo $optimization_jpg=='none'?'selected':''; ?>><?php _e('No compression'); ?></option>
            </select>
            <label for="optimization_jpg"><?php _e('JPG Optimization'); ?></label>
        </div>

        <div class="input-field col s3">
            <i class="material-icons prefix">settings_application</i>
            <select name="optimization_png">
                <option value="lossy" <?php echo $optimization_png=='lossy'?'selected':''; ?>><?php _e('Best Saving'); ?></option>
                <option value="lossless" <?php echo $optimization_png=='lossless'?'selected':''; ?>><?php _e('Lossless'); ?></option>
                <option value="none" <?php echo $optimization_png=='none'?'selected':''; ?>><?php _e('No compression'); ?></option>
            </select>
            <label for="optimization_png"><?php _e('PNG Optimization'); ?></label>
        </div>

        <div class="input-field col s3">
            <i class="material-icons prefix">settings_application</i>
            <select name="optimization_gif">
                <option value="lossy" <?php echo $optimization_gif=='lossy'?'selected':''; ?>><?php _e('Best Saving'); ?></option>
                <option value="lossless" <?php echo $optimization_gif=='lossless'?'selected':''; ?>><?php _e('Lossless'); ?></option>
                <option value="none" <?php echo $optimization_gif=='none'?'selected':''; ?>><?php _e('No compression'); ?></option>
            </select>
            <label for="optimization_gif"><?php _e('GIF Optimization'); ?></label>
        </div>

        <div class="input-field col s3">
            <i class="material-icons prefix">settings_application</i>
            <select name="optimization_pdf">
                <option value="lossy" <?php echo $optimization_pdf=='lossy'?'selected':''; ?>><?php _e('Best Saving'); ?></option>
                <option value="lossless" <?php echo $optimization_pdf=='lossless'?'selected':''; ?>><?php _e('Lossless'); ?></option>
                <option value="none" <?php echo $optimization_pdf=='none'?'selected':''; ?>><?php _e('No compression'); ?></option>
            </select>
            <label for="optimization_pdf"><?php _e('PDF Optimization'); ?></label>
        </div>
    </div>

    <h4><?php _e('Cron URL'); ?></h4>
    <div class="row">
        <div class="col s12">
            <p>
                <?php _e('You can run a cron task on this url to optimize automatically all url '); ?> : <br/>
                <strong><?php echo "http".(!empty($_SERVER['HTTPS'])?"s":"")."://".$_SERVER['SERVER_NAME'].dirname($_SERVER['REQUEST_URI']); ?>/cron.php?token=<?php echo $configuration->cron_token; ?></strong>
            </p>
        </div>
    </div>

    <h4><?php _e('Metadatas Settings'); ?></h4>
    <div class="row">
        <div class="input-field col s2">
            <input type="checkbox" name="preserve_meta_datetime" id="preserve_meta_datetime" <?php echo $preserve_meta_datetime=='1'?'checked':''; ?> />
            <label for="preserve_meta_datetime"><?php _e('Preserve datetime'); ?></label>
        </div>
        <div class="input-field col s2">
            <input type="checkbox" name="preserve_meta_location" id="preserve_meta_location" <?php echo $preserve_meta_location=='1'?'checked':''; ?> />
            <label for="preserve_meta_location"><?php _e('Preserve location'); ?></label>
        </div>
        <div class="input-field col s2">
            <input type="checkbox" name="preserve_meta_copyright" id="preserve_meta_copyright" <?php echo $preserve_meta_copyright=='1'?'checked':''; ?> />
            <label for="preserve_meta_copyright"><?php _e('Preserve copyright'); ?></label>
        </div>
        <div class="input-field col s2">
            <input type="checkbox" name="preserve_meta_orientation" id="preserve_meta_orientation" <?php echo $preserve_meta_orientation=='1'?'checked':''; ?> />
            <label for="preserve_meta_orientation"><?php _e('Preserve orientation'); ?></label>
        </div>
        <div class="input-field col s2">
            <input type="checkbox" name="preserve_meta_color_profile" id="preserve_meta_color_profile" <?php echo $preserve_meta_color_profile=='1'?'checked':''; ?> />
            <label for="preserve_meta_color_profile"><?php _e('Preserve color profile'); ?></label>
        </div>
    </div>

    <h4><?php _e('Folders Settings'); ?></h4>
    <div class="row">
        <div id="folderList">
            <?php
            if(!$folders) {
                $selectedFolders = array(DIRECTORY_SEPARATOR);
            }else{
                $selectedFolders = explode(',',$folders);
            }
            $root = realpath('../') . DIRECTORY_SEPARATOR;

            $files = \ImageRecycle\Standalone\Filesystem::listFiles($root,null,IR_ITERATOR_ONLYDIR);
            $content = PHP_EOL;
            $ul = array();
            for ($ij=0; $ij < count($files); $ij++) {
                $class = '';
                //Check if this folder should be selected
                foreach ($selectedFolders as $folder){
                    if($folder==='/'){
                        $class = 'checked';
                        continue;
                    }

                    $pos = strpos($folder,$files[$ij]);
                    $posParent = strpos($files[$ij],$folder);
                    if($folder===$files[$ij]){
                        $class = 'checked';
                        continue; //don't need to check more we already know all is selected
                    }elseif($pos===0){
                        $class = 'pchecked';
                    }elseif($posParent===0){
                        $class = 'checked';
                        continue; //don't need to check more we already know parent is selected
                    }
                }

                //If this is the first occurence we need to start list
                if( $ij===0 ){
                    $content .= '<ul>'.PHP_EOL;
                }

                $pathsParts = explode(DIRECTORY_SEPARATOR,$files[$ij]);

                //Not the last item and has no children
                if($ij+1 < count($files) && strpos($files[$ij+1],$files[$ij])===0){
                    $isParent = true;
                }else{
                    $isParent = false;
                }

                $content .= '<li>'.PHP_EOL;
                $content .= '<span class="check '.$class.'" data-folder="'.$files[$ij].'"></span>';
                if($isParent){
                    $content .= '<i class="material-icons">folder_open</i><a href="#">';
                }else{
                    $content .= '<i class="material-icons">remove</i>';
                }
                $content .= $pathsParts[count($pathsParts)-1];
                if($isParent){
                    $content .= '</a>';
                }

                $endli = true;
                //Check if there is a children after the current item
                if(
                    $ij+1 < count($files) && //Not the last item
                    strpos($files[$ij+1],$files[$ij])===0  //This is a children we open a new ul
                ){
                    $content .= '<ul>'.PHP_EOL;

                    $ul[count($ul)] = $pathsParts[count($pathsParts)-1];
                    $endli = false;
                }else{
                    for ($ik = count($ul) - 1; $ik >= 0; $ik--) {
                        //If it's last item or next one not under the last same parent
                        if ($ij + 1 === count($files) || strpos($files[$ij + 1], implode(DIRECTORY_SEPARATOR,array_slice($ul,0,$ik+1))) !== 0) {
                            $content .= '</li>' . PHP_EOL . '</ul>' . PHP_EOL;
                            unset($ul[$ik]);
                        }
                    }
                }

                if($endli){
                    $content .= '</li>'.PHP_EOL;
                }

                if($ij + 1 === count($files) ){
                    $content .= '</ul>';
                }
            }

            if($selectedFolders[0]==='/'){
                $class = 'checked';
            }else{
                $class = 'pchecked';
            }
            $content = '<ul><li><span class="check '.$class.'" data-folder="/"></span><i class="material-icons">folder_open</i>/'.$content.'</li></ul>';

            echo $content;
            ?>
        </div>
    </div>
    <input type="hidden" name="page" value="settings" />
    <input type="hidden" name="folders" id="folderInput" />
    <button type="submit" class="waves-effect waves-light btn right"><i class="material-icons right">check</i><?php _e('Save'); ?></button>
</form>
<script>
    $(document).ready(function() {
        $('select').material_select();
    });

    //Close all items by default
    $('#folderList li li').addClass('closed');

    $('#folderList .check').click(function(){
        $this = $(this);
        $li = $this.parent();

        isChecked = $this.hasClass('checked');

        //Remove all class for childrens
        $li.find('span.check').removeClass('checked pchecked');

        if(!isChecked){
            $li.find('span.check').addClass('checked');
        }

        //Uncheck all parents
        $liParents = $li.parents('li');
        $liParents.children('span.check').removeClass('checked pchecked');

        //Check if childrens are all/none/some checked
        $liParents.each(function() {
            $this = $(this);
            total = $this.find('ul > li span.check').length;
            checked = $this.find('ul > li span.check.checked').length;

            if(checked == 0){
                $this.children('span.check').removeClass('checked pchecked');
            } else if(checked < total){
                $this.children('span.check').addClass('pchecked');
            } else if(checked == total){
                $this.children('span.check').addClass('checked');
            }
        });
    });

    $('#folderList a').click(function(e){
        e.preventDefault();
        $parent = $(this).parent();
        $icon = $(this).siblings('i');
        if($parent.hasClass('closed')){
            $parent.removeClass('closed');
            $icon.html('folder_open');
        }else{
            $parent.addClass('closed');
            $icon.html('folder');
        }
    });

    $('form').on('submit',function(){
        //Get all selected folders
        getSelectedFolders = function(folder){
            console.log($(folder).find(' > li > span.check'));
            folder.find(' > li > span.check').each(function(){
                $this = $(this);
                if($this.hasClass('checked')){
                    foldersSelected.push($this.data('folder'));
                }else if($this.hasClass('pchecked')){
                    getSelectedFolders($this.parent().children('ul'));
                }
            });
        };
        foldersSelected = [];
        getSelectedFolders($('#folderList > ul'));
        $('#folderInput').val(foldersSelected.toString());
    });
</script>